package wa2.repositories;

import org.hibernate.HibernateException;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.Transaction;
import org.hibernate.cfg.Configuration;
import wa2.entities.Customer;

import java.util.List;

public class DBRepository{
    private static final SessionFactory ourSessionFactory;

    static {
        try {
            Configuration configuration = new Configuration();
            configuration.configure();

            configuration.addAnnotatedClass(Customer.class);

            ourSessionFactory = configuration.buildSessionFactory();
        } catch (Throwable ex) {
            throw new ExceptionInInitializerError(ex);
        }
    }

    public static Session getSession() throws HibernateException {
        return ourSessionFactory.openSession();
    }


    public List<Customer> getAll(int start, int pageSize) {
        Session session = getSession();
        Transaction transaction = session.beginTransaction();

        List<Customer> result = session
                .createQuery("from Customer c ORDER BY c.Name desc")
                .setFirstResult(start)
                .setMaxResults(pageSize).list();

        transaction.commit();

        return result;
    }
}
